'-----------------------
'	  Embed Signage 
'-----------------------
Sub Main()
	
	' AddVM()

	setUpNetwork()

	setUPPlayer()

End Sub

Function AddVM() as Void

	options = CreateObject("roAssociativeArray")
	options.filename = "embed_swap"
	options.megabytes = 1000

	roVirt = CreateObject("roVirtualMemory")

	roVirt.RemoveSwapFile("embed_swap")
	' roVirt.AddSwapFile(options)

End Function

Function setUpPlayer() As Void

	' Set up global variables
	CreateGlobalVars()
	
	sleep(5000)
	' Show html player
	m.embed["appHTML"].Show()

	' Listen for events
	ListenForEvents()

End Function

Function CreateGlobalVars() as Void

	globalVars = CreateObject("roAssociativeArray")
	m.embed = globalVars

	m.embed["logger"] = CreateObject("roSystemLog")
	m.embed["singleRen"] = false
	m.embed["singleRenRen"] = "Ren1"

	m.embed["deviceInfo"] = CreateObject("roDeviceInfo")
	
	' New multi output changes.
	m.embed["videoMode"] = CreateObject("roVideoMode")

	' Set graphics order so html in middle of video player toFront/html/toBack
	m.embed["videoMode"].SetGraphicsZOrder("middle")

	m.embed["registrySection"] 	= CreateObject("roRegistrySection", "embedinfo")
	m.embed["resolution"] 		= GetResolution()

	m.embed["msgPort"] = CreateObject("roMessagePort")
	m.embed["appHTML"] = CreateAppHTML()

	m.embed["playerHTML"] = false

	m.embed["videoPlayerType"] = "default"
	m.embed["logger"].SendLine("Embed.INFO: VideoPlayer: default")


End Function

Sub ListenForEvents() as Void

	while true
	    
	    msg = wait(0, m.embed["msgPort"])
	    
	    if type(msg) = "roHtmlWidgetEvent" then
	        
	        eventData = msg.GetData()
	        
	        if type(eventData) = "roAssociativeArray" and type(eventData.reason) = "roString" then
	            
	            if eventData.reason = "load-error" then
	            
	                print "message = ";eventData.message
	            
	            endif

				if eventData.reason = "message" then

					HandleJSComs( eventData )

				endif 

	        endif

	    endif

	end while

End Sub

Function CreateAppHTML() as Object

	is = {
	    port: 3000
	}
	
	config = {
	    nodejs_enabled: true
	    brightsign_js_objects_enabled: true
	    mouse_enabled: true
	    url: "file:///index.html"
	    ' security_params: {websecurity: false}
	    storage_path: "SD:/info/app"
		storage_quota: 25000000'268435456
		' inspector_server: is
	}

	model = m.embed["deviceInfo"].GetModel()
	height = m.embed["resolution"]["Height"]
	width = m.embed["resolution"]["Width"]

	if newModels(model) = false then

		if m.embed["resolution"]["Orientation"] = "portrait" then 
			config.transform = "rot90"
		endif

		if m.embed["resolution"]["Orientation"] = "reversedPortrait" then 

			config.transform = "rot270"

		endif

	else

		if m.embed["resolution"]["Orientation"] = "portrait" then 
			width = m.embed["resolution"]["Height"]
			height = m.embed["resolution"]["Width"]
		endif

		if m.embed["resolution"]["Orientation"] = "reversedPortrait" then 
			width = m.embed["resolution"]["Height"]
			height = m.embed["resolution"]["Width"]
		endif

	endif

	fullRes = false
	

	

	if fullResModels(model) then
		fullRes = true
	endif

	if fullRes = false then '!XT4 do original sizing.
		if width = 3840 then
			width = 1920
		endif

		if width = 4096 then
			width = 2048
		endif

		if height = 2160 then
			height = 1080
		endif
	endif

	r = CreateObject("roRectangle", 0, 0, width, height)

	h = CreateObject("roHtmlWidget", r, config)

	h.EnableSecurity(true)
	
	h.SetPort(m.embed["msgPort"])

	return h

End Function

Function CreatePlayerHTML() as Object

	fullRes = false
	fullResString = "false"

	height = m.embed["resolution"]["Height"]
	width = m.embed["resolution"]["Width"]
	orientation = m.embed["resolution"]["Orientation"]

	originalHeight = StrI(height)
	originalWidth = StrI(width)

	model = m.embed["deviceInfo"].GetModel()

	if fullResModels(model) then
		fullRes = true
		fullResString = "true"
	endif

	if fullRes = false then '!XT4 do original sizing.
		if width = 3840 then
			width = 1920
		endif

		if width = 4096 then
			width = 2048
		endif

		if height = 2160 then
			height = 1080
		endif
	endif

	is = {
	    port: 3001
	}

	
	
	config = {
	    nodejs_enabled: true
	    brightsign_js_objects_enabled: true
	    mouse_enabled: true
	    url: "file:///files/embedapp.html?bs=true&version=2.0.7&width="+originalWidth+"&height="+originalHeight+"&orientation="+orientation+"&videoMode="+m.embed["videoModeString"]+"&fullres=" + fullResString
	    ' security_params: {websecurity: false}
	    storage_path: "SD:/info/player"
		storage_quota: 25000000'268435456
		' inspector_server: is
	}

	' if orientation = "portrait" then 
	' 	config.transform = "rot90"
	' endif

	' if orientation = "reversedPortrait" then 
	' 	config.transform = "rot270"
	' endif

	if newModels(model) = false then

		if orientation = "portrait" then 
			config.transform = "rot90"
		endif

		if orientation = "reversedPortrait" then 

			config.transform = "rot270"

		endif

	else

		if orientation = "portrait" then 
			width = m.embed["resolution"]["Height"]
			height = m.embed["resolution"]["Width"]
			
		endif

		if orientation = "reversedPortrait" then 
			width = m.embed["resolution"]["Height"]
			height = m.embed["resolution"]["Width"]
		endif

	endif

	m.embed["logger"].SendLine("Embed.INFO: PlayerHTML width: " + StrI(width))
	m.embed["logger"].SendLine("Embed.INFO: PlayerHTML height: " + StrI(height))

	r = CreateObject("roRectangle", 0, 0, width, height)

	h = CreateObject("roHtmlWidget", r, config)

	h.EnableSecurity(true)
	
	h.SetPort(m.embed["msgPort"])

	return h

End Function

Function HandleJSComs( eventData ) as Void

	if eventData.message.module = "Browser" then
		PerformBrowserAction( eventData.message )
	endif

	if eventData.message.module = "Logs" then
		PerformLogAction( eventData.message )
	endif

End Function

Function PerformBrowserAction( message ) as Void 

	if message.action = "show" then
		m.embed["playerHTML"] = invalid
		sleep(500)

		m.embed["playerHTML"] = CreatePlayerHTML()
		m.embed["playerHTML"].Show()
		m.embed["appHTML"].Hide()
	endif

	if message.action = "hide" then
		m.embed["appHTML"].Show()

		if type(m.embed["playerHTML"]) = "roHtmlWidget" then
			m.embed["playerHTML"].Hide()
		endif

		m.embed["playerHTML"] = invalid
		sleep(500)
	endif

End Function

Function PerformLogAction( message ) as Void 

	if message.action = "get" then

		logFile = CreateObject("roCreateFile", "log.txt")

		logs = m.embed["logger"].ReadLog()

		for each line in logs
			logFile.SendLine(line)
		end for

		m.embed["appHTML"].PostJSMessage({ message: "logsStored" })
	endif

End Function

Function fullResModels(model as String) as Boolean

	arr = CreateObject("roArray", 0, true)
	arr.push("XC2055")
	arr.push("XC4055")
	' arr.push("XT1144")
	' arr.push("XT244")
	arr.push("XT245")
	arr.push("XT1145")
	arr.push("XT2145")

	mode = m.embed["videoMode"].GetActiveMode()
	nonFullResXT3 = CreateObject("roArray", 0, true)
	xt3fullRes = true

	m.embed["videoModeString"] = mode.videomode

	nonFullResXT3.push("3840x2160x50p")
	nonFullResXT3.push("3840x2160x59.94p")
	nonFullResXT3.push("3840x2160x60p")
	nonFullResXT3.push("4096x2160x50p")
	nonFullResXT3.push("4096x2160x59.94p")
	nonFullResXT3.push("4096x2160x60p")

	for each entry in nonFullResXT3
        if entry = m.embed["videoModeString"]
            xt3fullRes = false
        end if
    end for

	if xt3fullRes = true then
		' arr.push("XT1143")
		' arr.push("XT243")
	end if

    for each entry in arr
        if entry = model
            return true
        end if
    end for
    return false
End function

Function multiOutputModels(model as String) as Boolean

	arr = CreateObject("roArray", 0, true)
	arr.push("XC2055")
	arr.push("XC4055")
	arr.push("XT2145")
	

    for each entry in arr
        if entry = model
            return true
        end if
    end for
    return false
End function

Function newModels(model as String) as Boolean

	arr = CreateObject("roArray", 0, true)
	arr.push("XC2055")
	arr.push("XC4055")

	if Right( model, 1 ) = "5" then
		return true
	else
		return false
	endif
    ' for each entry in arr
    '     if entry = model
    '         return true
    '     end if
    ' end for
    ' return false
End function

Function newModelsAndXT44(model as String) as Boolean

	arr = CreateObject("roArray", 0, true)
	arr.push("XT1144")
	arr.push("XT244")
	arr.push("XT1143")
	arr.push("XC2055")
	arr.push("XC4055")

    ' for each entry in arr
    '     if entry = model
    '         return true
    '     end if
    ' end for
    ' return false

	if Right( model, 1 ) = "5" then
		return true
	else
		if model = "XT1144" then
			return true
		else
			return false
		endif
	endif

End function

Function GetResolution() as Object

	exists = m.embed["registrySection"].Exists("resolutionwidth")

	width = 1920
	height = 1080
	orientation = "landscape"

	if exists then

		width = val( m.embed["registrySection"].Read("resolutionwidth") )

	endif

	exists = m.embed["registrySection"].Exists("resolutionheight")

	if exists then

		height = val( m.embed["registrySection"].Read("resolutionheight") )

	endif

	exists = m.embed["registrySection"].Exists("orientation")

	if exists then

		orientation = m.embed["registrySection"].Read("orientation")

	endif

	Resolution = CreateObject("roAssociativeArray")

	Resolution["Width"] = width
	Resolution["Height"] = height
	Resolution["Orientation"] = orientation

	model = m.embed["deviceInfo"].GetModel()

	if multiOutputModels(model) then

		OutputsModes = m.embed["videoMode"].GetScreenModes()
		maxWidth = 0
		maxHeight = 0

		for each mode in OutputsModes

			if mode.enabled then

				firstPos = Instr(1, mode.video_mode, "x") - 1
				resWidth = Left(mode.video_mode, firstPos).toInt()

				secondPosString = Right( mode.video_mode, Len(mode.video_mode) - firstPos - 1 )
				secondPos = Instr(1, secondPosString, "x") - 1

				resHeight = Left(secondPosString, secondPos).toInt()

				if mode.transform = "normal" then

					totalHeight = resHeight + mode.display_y
					if totalHeight > maxHeight then
						
						maxHeight = totalHeight

					endif

					totalWidth = resWidth + mode.display_x
					if totalWidth > maxWidth then
						
						maxWidth = totalWidth

					endif

				endif

				if mode.transform = "180" then

					totalHeight = resHeight + mode.display_y
					if totalHeight > maxHeight then
						
						maxHeight = totalHeight

					endif

					totalWidth = resWidth + mode.display_x
					if totalWidth > maxWidth then
						
						maxWidth = totalWidth

					endif

				endif

				if mode.transform = "90" then

					totalHeight = resWidth + mode.display_y
					if totalHeight > maxHeight then
						
						maxHeight = totalHeight

					endif

					totalWidth = resHeight + mode.display_x
					if totalWidth > maxWidth then
						
						maxWidth = totalWidth

					endif

				endif

				if mode.transform = "270" then

					totalHeight = resWidth + mode.display_y
					if totalHeight > maxHeight then
						
						maxHeight = totalHeight

					endif

					totalWidth = resHeight + mode.display_x
					if totalWidth > maxWidth then
						
						maxWidth = totalWidth

					endif

				endif

				m.embed["logger"].SendLine("Embed.INFO: maxresWidth: " + StrI(maxWidth))
				m.embed["logger"].SendLine("Embed.INFO: maxresHeight: " + StrI(maxHeight))

			endif
		end for

		if maxWidth > 0 then 
			Resolution["Width"] = maxWidth
			Resolution["Height"] = maxHeight
		endif

	endif

	return Resolution

End Function


'-----------------------
'		Network
'-----------------------

Function setUpNetwork() As Void

	networkConfig = CreateObject("roRegistrySection", "embednetwork")

	networkInterfaceExists = networkConfig.Exists("networkinterface")
	networkUpdatesExist = networkConfig.Exists("networkupdates")

	' reg = CreateObject("roRegistrySection", "networking")
	' reg.delete("ssh")
	' ' reg.write("ssh","22")
	' ' n=CreateObject("roNetworkConfiguration", 0)
	' ' n.SetLoginPassword("password")
	' ' n.Apply()

	if networkUpdatesExist then 

		networkUpdates = networkConfig.Read("networkupdates")

		if networkUpdates = "yes" then
			if networkInterfaceExists then

				networkInterface = networkConfig.Read("networkinterface")

				if networkInterface = "wifi" then

					setUpWifi()

				else

					setUpEthernet()
				
				endif

			' else

			' 	setUpEthernetFallback()
				
			endif 
		endif
	endif

End Function

Function setUpEthernetFallback() As Void

	nc = CreateObject("roNetworkConfiguration",0)

	if type(nc) = "roNetworkConfiguration" then 

		nc.SetDHCP()

		nc.SetRoutingMetric(0)

		nc.Apply()

	endif

	disableWifi()
	
End Function


Function setUpEthernet() As Void

	nc = CreateObject("roNetworkConfiguration",0)

	if type(nc) = "roNetworkConfiguration" then 

		networkConfig = CreateObject("roRegistrySection", "embednetwork")
		
		networkTypeExists = networkConfig.Exists("networktype")

		if networkTypeExists then

			networkType = networkConfig.Read("networktype")

			if networkType = "manual" then

				ipExists = networkConfig.Exists("ipaddress")
				maskExists = networkConfig.Exists("subnetmask")
				gatewayExists = networkConfig.Exists("gateway")
				dnsExists = networkConfig.Exists("dns1")
				dns2Exists = networkConfig.Exists("dns2")
				dns3Exists = networkConfig.Exists("dns3")

				if ipExists and maskExists and gatewayExists and dnsExists then

					ipAddress = networkConfig.Read("ipaddress")
					subnet = networkConfig.Read("subnetmask")
					gateway = networkConfig.Read("gateway")

					dns1 = networkConfig.Read("dns1")

					nc.SetIP4Address(ipAddress)
					nc.SetIP4Netmask(subnet)
					' nc.SetIP4Broadcast(gateway)
					nc.SetIP4Gateway(gateway)

					dns = CreateObject("roArray", 1, true)

					dns.Push(dns1)

					if dns2Exists then

						dns2 = networkConfig.Read("dns2")
						dns.Push(dns2)

					endif

					if dns3Exists then

						dns3 = networkConfig.Read("dns3")
						dns.Push(dns3)
						
					endif				

					nc.SetDNSServers(dns)

				else

					nc.SetDHCP()

				endif


			else

				nc.SetDHCP()

			endif

		else 

			nc.SetDHCP()

		endif

		proxyExists = networkConfig.Exists("useproxy")

		if proxyExists then

			useProxy = networkConfig.Read("useproxy")

			if useProxy = "yes" then		
				
				proxystringExists = networkConfig.Read("proxystring")

				if( proxystringExists )
					proxy 	= networkConfig.Read("proxystring")
					nc.SetProxy(proxy)
				else

					nc.SetProxy("")

				endif

			else

				nc.SetProxy("")

			endif

		else

			nc.SetProxy("")

		endif

		nc.SetRoutingMetric(0)

		nc.Apply()

	endif

	networkTypeExists = networkConfig.Exists("networkupdates")

	if networkTypeExists then

		networkConfig.Delete("networkupdates")
		networkConfig.Delete("wifipassword")

	endif

	disableWifi()
	
End Function

Function disableWifi() as Void

	nc = CreateObject("roNetworkConfiguration",1)

	if type(nc) = "roNetworkConfiguration" then 
	
		nc.SetWiFiESSID("")
		nc.SetWiFiPassphrase("")

		nc.SetRoutingMetric(1)

		nc.Apply()

	endif

End Function

Function setUpWifi() As Void
	
	nc = CreateObject("roNetworkConfiguration",1)

	if type(nc) = "roNetworkConfiguration" then 

		networkConfig = CreateObject("roRegistrySection", "embednetwork")
		
		networkTypeExists = networkConfig.Exists("networktype")

		if networkTypeExists then

			networkType = networkConfig.Read("networktype")

			if networkType = "manual" then

				ipExists = networkConfig.Exists("ipaddress")
				maskExists = networkConfig.Exists("subnetmask")
				gatewayExists = networkConfig.Exists("gateway")
				dnsExists = networkConfig.Exists("dns1")
				dns2Exists = networkConfig.Exists("dns2")
				dns3Exists = networkConfig.Exists("dns3")

				if ipExists and maskExists and gatewayExists and dnsExists then

					ipAddress = networkConfig.Read("ipaddress")
					subnet = networkConfig.Read("subnetmask")
					gateway = networkConfig.Read("gateway")

					dns1 = networkConfig.Read("dns1")

					nc.SetIP4Address(ipAddress)
					nc.SetIP4Netmask(subnet)
					' nc.SetIP4Broadcast(gateway)
					nc.SetIP4Gateway(gateway)

					dns = CreateObject("roArray", 1, true)

					dns.Push(dns1)

					if dns2Exists then

						dns2 = networkConfig.Read("dns2")
						dns.Push(dns2)

					endif

					if dns3Exists then

						dns3 = networkConfig.Read("dns3")
						dns.Push(dns3)
						
					endif				

					nc.SetDNSServers(dns)

				else

					nc.SetDHCP()

				endif


			else

				nc.SetDHCP()

			endif

		else 

			nc.SetDHCP()

		endif

		wifiConfigExists = networkConfig.Exists("wifiSSID")

		if wifiConfigExists then 

			SSID = networkConfig.Read("wifiSSID")
			Passphrase = networkConfig.Read("wifiPassword")

			basesixfour = CreateObject("roByteArray")
			basesixfour.FromBase64String(Passphrase)

			nc.SetWiFiESSID(SSID)
			nc.SetWiFiPassphrase(basesixfour.ToAsciiString())

			nc.SetRoutingMetric(0)

		endif

		proxyExists = networkConfig.Exists("useproxy")

		if proxyExists then

			useProxy = networkConfig.Read("useproxy")

			if useProxy = "yes" then		
				
				proxystringExists = networkConfig.Read("proxystring")

				if( proxystringExists )
					proxy 	= networkConfig.Read("proxystring")
					nc.SetProxy(proxy)
				else

					nc.SetProxy("")

				endif

			else

				nc.SetProxy("")

			endif

		else

			nc.SetProxy("")

		endif

		nc.Apply()

	endif

	ethc = CreateObject("roNetworkConfiguration",0)

	if type(ethc) = "roNetworkConfiguration" then 

		if wifiConfigExists then 
			
			ethc.SetRoutingMetric(1)
		else
			ethc.SetRoutingMetric(0)
		endif

		ethc.Apply()

	endif

	networkTypeExists = networkConfig.Exists("networkupdates")

	if networkTypeExists then

		networkConfig.Delete("networkupdates")
		networkConfig.Delete("wifipassword")

	endif

End Function