// ----------------------
// ----- Messages ------
// ----------------------

var EmbedMessages = function()
{

    this.getDomElements();

};

EmbedMessages.prototype.getDomElements = function()
{

    this.domEl = {};

    this.domEl.status       = document.getElementById('status');
    this.domEl.belowStatus  = document.getElementById('belowStatus');

};

EmbedMessages.prototype.messages = { 
    'welcome' : { 
        'title'         : 'Welcome',
        'description'   : 'To begin, please connect this device to the internet.',
        'color'         : '#67d4c3'
    },
    'code' : { 
        'title'         : '',
        'description'   : 'Use the code above to register this device to your embedsignage.com account.',
        'color'         : '#67d4c3'
    },
    'registered' : { 
        'title'         : 'Device Registered',
        'description'   : 'Congratulations, this device has been registered. Next step, please assign this device to a channel.',
        'color'         : '#67d4c3'
    },
    'connection' : { 
        'title'         : 'Connection Lost',
        'description'   : 'This device has not connected to<br>embed signage for more than 28 days.<br>Please connect this device to the internet to resume playback.',
        'color'         : '#d9534f'
    },
    'expired' : { 
        'title'         : 'Expired License',
        'description'   : 'This device is suspended due to an expired license.',
        'color'         : '#d9534f'
    },
    'noFiles' : {
        'title'         : 'No Files!',
        'description'   : 'Please publish the channel.',
        'color'         : '#f0ad4e',
    },
    'channelTooBig' : {
        'title'         : 'Cannot Download',
        'description'   : 'The channel you have published is too big for this device. Please switch to external storage or modify your channel accordingly.',
        'color'         : '#f0ad4e',
    },
    'downloading' : {
        'title'         : 'Downloading Files',
        'description'   : '',
        'color'         : '#67d4c3'
    },
    'downloadFailed' : {
        'title'         : 'Download Failed',
        'description'   : '',
        'color'         : '#d9534f'
    },
    'noInternetConnection' : {
        'title'         : 'No Internet Connection!',
        'description'   : 'No internet connection. Please check your network settings.',
        'color'         : '#d9534f',
    },
    'noPhysicalConnection' : {
        'title'         : 'No Network Connection!',
        'description'   : 'No network connection. Please check your network settings.',
        'color'         : '#d9534f',
    },
    'troubleshooting' : {
        'title'         : 'Troubleshooting!',
        'description'   : 'The application will reload when finished',
        'color'         : '#f0ad4e',
    },
    'setup' : {
        'title'         : 'Set up your player!',
        'description'   : 'You need to set up your player, visit this address in your browser.',
        'color'         : '#f0ad4e',
    }
};

EmbedMessages.prototype.show = function( id )
{

    this.current = this.messages[id];


    this.domEl.status.style.backgroundColor = this.current.color;

    this.domEl.status.querySelectorAll('p')[0].innerText = this.current.title;
    this.domEl.belowStatus.querySelectorAll('p')[0].innerText = this.current.description;

};

EmbedMessages.prototype.hide = function()
{

};