

// ----------------------
// ---- Notifications ---
// ----------------------

var EmbedNotification = function()
{

    this.sentNotifications = {};

};

EmbedNotification.prototype.send = function( notification )
{

    
    
    var date    = new Date();

    var offset = date.getTimezoneOffset();

    // date = new Date(date.valueOf() + offset * 60000);

    var strNotification = JSON.stringify(notification.body);

    if( !this.sentNotifications[strNotification] || ( date.getTime() - this.sentNotifications[strNotification] ) >= 900000 )
    {   
        
        var request = new Request({
            'url'   : app.config.url + '/api/v2/' + app.device.accountKey + '/notification',
            'type'  : 'POST',
            'data'  : { 
                'deviceID' : app.device.details.embedID,
                'notifications' : [
                    {
                        'section'       : 'devices',
                        'section_id'    : '0',
                        'type'          : notification.type,
                        'title'         : notification.title,
                        'body'          : notification.body,
                        'occured_at'    : date.toString(),
                        'dismisable'    : 1,
                        'additional'    : {},
                        'email'         : 0,
                        'emailSettings' : {
                            'template'      : 'Basic',
                            'preferences'   : 'NA',
                            'subject'       : notification.title,
                            'content'       : {
                                'intro' : notification.title,
                                'body'  : notification.body
                            }
                        }

                    }
                ]
            }
        });

        request.onSuccess = this.requestSuccess.bind({'this':this, 'strNotification' : strNotification, 'date' : date.getTime()});

        request.onError = this.requestError.bind(this);

    }
    
};

EmbedNotification.prototype.requestSuccess = function( response )
{

    if( !response.error )
    {
        this.this.sentNotifications[ this.strNotification ] = this.date;
    }

};

EmbedNotification.prototype.requestError = function()
{

};