// ======================================================================================
// ======================================================================================
// ======================================================================================
// ======================================================================================
// ======================================================================================
// ======================================================================================
// =Request=
// ======================================================================================
// ======================================================================================
// ======================================================================================
// ======================================================================================
// ======================================================================================

var Request = function(options)
{

    this.options = options;

    if( typeof this.options.autoSend == 'undefined' || this.options.autoSend == true )
    {
        this.send();
    }

    return this;

}

Request.prototype.send = function()
{

    switch( this.options.type )
    {
        case 'POST' :
            this.post();
        break;

        case 'GET' :
            this.get();
        break;

        case 'JSONP' :
            this.jsonp();
        break;
    }

}

Request.prototype.post = function()
{

    if( !this.options.data.deviceID )
    {
        this.options.data.deviceID = app.device.details.embedID;
    }

    var params = this.getPostData(this.options.data);

    var request = new XMLHttpRequest();

    request.open( 'POST', this.options.url, true );

    if( this.options.contentType )
    {
        request.setRequestHeader("Content-type",  this.options.contentType);
    }
    else
    {
        request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    }

    request.onload = function() {
        if ( ( request.status >= 200 && request.status < 400 ) || ( request.responseText && request.responseText != '' ) ) {

            if( !this.options.contentType || this.options.contentType == 'json' )
            {
                try {
	        		var data = JSON.parse(request.responseText);	
	        	}
	            catch (e)
	            {
	            	var data = request.responseText;
	            }
            }
            else
            {
                var data = request.responseText;
            }

            if( this.onSuccess )
            {

                this.onSuccess( data );

            }
        } 
        else 
        {

            if( this.onError )
            {

                this.onError();

            }
        }
    }.bind(this);

    request.onerror = function() {

        if( this.onError )
        {

            this.onError();

        }

    }.bind(this);

    request.send(params);
}

Request.prototype.get = function()
{

    var params = this.getPostData(this.options.data);
    var request = new XMLHttpRequest();

    request.open( 'GET', this.options.url + '?' + params, true );

    // request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");

    request.onload = function() {
        if( ( request.status >= 200 && request.status < 400 ) || ( request.responseText && request.responseText != '' ) ) {

        	try {
        		var data = JSON.parse(request.responseText);	
        	}
            catch (e)
            {
            	var data = request.responseText;
            }

            if( this.onSuccess )
            {

                this.onSuccess( data );

            }
        } 
        else 
        {

            if( this.onError )
            {

                this.onError();

            }
        }
    }.bind(this);

    request.onerror = function() {

        if( this.onError )
        {

            this.onError();

        }

    }.bind(this);

    request.send();
    
};

Request.prototype.jsonp = function()
{

    var callbackName = 'jsonp_callback_' + Math.round(100000 * Math.random());

    window[callbackName] = function(data) {

        delete window[callbackName];

        document.body.removeChild(script);
        
        this.onSuccess(data);

    }.bind(this);

    var params = this.getPostData(this.options.data);

    var url = this.options.url;

    if( params )
    {
        url = url + '?' + params;   
    }

    var script = document.createElement('script');
    script.src = url + (url.indexOf('?') >= 0 ? '&' : '?') + 'jsonp=' + callbackName;
    document.body.appendChild(script);

};

Request.prototype.buildParams = function (prefix, obj, traditional, add) {

    if (Array.isArray(obj)) {

        // Serialize array item.
        for (var objKey in obj) {

            if (traditional || /\[\]$/.test(prefix)) {

                add(prefix, obj[objKey]);

            } else {

                this.buildParams(prefix + "[" + ( typeof obj[objKey] === "object" || Array.isArray(obj[objKey]) ? objKey : "" ) + "]", obj[objKey], traditional, add);

            }

        }

    } else if (!traditional && obj != null && typeof obj === "object") {

        // Serialize object item.
        for (var objKey in obj) {

            this.buildParams(prefix + "[" + objKey + "]", obj[objKey], traditional, add);

        }

    } else {
        // Serialize scalar item.
        add(prefix, obj);

    }

};

Request.prototype.getPostData = function (a) {

    var s = [], add = function (key, value) {

        s[s.length] = encodeURIComponent(key) + "=" + encodeURIComponent(value);

    };

    for (var prefix in a) {

        this.buildParams(prefix, a[prefix], false, add);

    }

    // Return the resulting serialization
    return s.join("&").replace(/%20/g, "+");

};