function init()
{

	window.embed = new EmbedSettings();

}

window.addEventListener('load', init);


function EmbedSettings()
{

	this.init();

};

EmbedSettings.prototype.init = function() 
{

	// this.loadModules();
	// 

	this.applyEvents();

	if( data.setup )
	{
		this.loadSetup();
	}
	else
	{
		this.loadPage('home');
	}

	// this.loadConfiguration();

};

EmbedSettings.prototype.applyEvents = function()
{

	
	var menuItems = document.getElementsByClassName('menuOption');

	for( var i = 0; i < menuItems.length; i++ )
	{

		menuItems[i].addEventListener( 'click', this.menuClick.bind(this) );

	}

	var troubleshootButton = document.getElementsByClassName('troubleshootDevice');

	for( var i = 0; i < troubleshootButton.length; i++ )
	{

		troubleshootButton[i].addEventListener( 'click', this.troubleshootClicked.bind(this) );

	}

	var troubleshootCancel = document.getElementsByClassName('cancelTroubleshoot');

	for( var i = 0; i < troubleshootCancel.length; i++ )
	{

		troubleshootCancel[i].addEventListener( 'click', this.troubleshootCancel.bind(this) );

	}




	var troubleshootplayerButton = document.getElementsByClassName('troubleshootPlayer');

	for( var i = 0; i < troubleshootplayerButton.length; i++ )
	{

		troubleshootplayerButton[i].addEventListener( 'click', this.troubleshootPlayerClicked.bind(this) );

	}

	var troubleshootplayerCancel = document.getElementsByClassName('cancelTroubleshootPlayer');

	for( var i = 0; i < troubleshootplayerCancel.length; i++ )
	{

		troubleshootplayerCancel[i].addEventListener( 'click', this.troubleshootPlayerCancel.bind(this) );

	}


	var networkForm = document.getElementById('networkForm');
	var setupForm = document.getElementById('setupForm');

	if( networkForm )
	{
		networkForm.addEventListener('submit', this.validateForm.bind(this));
	}

	if( setupForm )
	{
		setupForm.addEventListener('submit', this.validateForm.bind(this));
	}



	var ethDHCPOn 	= document.getElementById('ethDHCPOn');
	var ethDHCPOff 	= document.getElementById('ethDHCPOff');
	var networkInterface 	= document.getElementById('networkInterface');

	ethDHCPOff.addEventListener('change', this.toggleIPConfig.bind(this));
	ethDHCPOn.addEventListener('change', this.toggleIPConfig.bind(this));

	networkInterface.addEventListener('change', this.toggleInterfaceConfig.bind(this));

	var refreshSSIDs = document.getElementById('refreshSSIDs');

	var wifiNetworkOption = document.getElementById('wifiNetwork');
	wifiNetworkOption.addEventListener('change', this.toggleWifiNetworkConfig.bind(this));

	refreshSSIDs.addEventListener('click', function(evt) {
		evt.preventDefault();

		this.loadWifiList();
	}.bind(this));

};

EmbedSettings.prototype.validateForm = function(evt)
{

	

	var validatedFields = evt.target.getElementsByClassName('validatedInput');
	var allFields = evt.target.querySelectorAll('input,select,textarea');

	var errors = [];
	var values = {};	

	for( var i = 0; i < allFields.length; i++ )
	{
		values[ allFields[i].id ] = allFields[i].value;
		allFields[i].classList.remove('validationError');
	}

	for( var i = 0; i < validatedFields.length; i++ )
	{

		var rules = validatedFields[i].getAttribute('data-rules');

		if( rules )
		{
			rules = rules.split(',');

			if( rules.length )
			{
				var passes = this.validateInput(validatedFields[i], rules, values);

				if( !passes )
				{
					errors.push(validatedFields[i]);
				}
			}

		}

	}

	if( errors.length )
	{
		evt.preventDefault();


		for( var i = 0; i < errors.length; i++ )
		{
			errors[i].classList.add('validationError');
		}
		
	}

};

EmbedSettings.prototype.validateInput = function(input, rules, values)
{

	var errors = [];

	

	for( var i = 0; i < rules.length; i++ )
	{
		
		if( rules[i].indexOf('requiredIf:') != -1 )
		{

			var ruleQuery = rules[i].replace('requiredIf:', '').split('=');
			
			if( values[ruleQuery[0]] == ruleQuery[1] && ( !input.value || input.value == '' ) )
			{
				errors.push(rules[i]);
			}
		}
		else if( rule[i].indexOf('required') != -1 )
		{
			if( !input.value || input.value == '' )
			{
				errors.push(rules[i]);
			}
		}

	}

	if( errors.length )
	{
		return false;
	}
	
	return true;

};

EmbedSettings.prototype.troubleshootClicked = function( evt )
{
	evt.preventDefault();

	var troubleshootConfirmation = document.getElementsByClassName('troubleshootConfirmation')[0];

	troubleshootConfirmation.classList.add('visible');

};

EmbedSettings.prototype.troubleshootCancel = function( evt )
{
	evt.preventDefault();

	var troubleshootConfirmation = document.getElementsByClassName('troubleshootConfirmation')[0];

	troubleshootConfirmation.classList.remove('visible');

};


EmbedSettings.prototype.troubleshootPlayerClicked = function( evt )
{
	evt.preventDefault();

	var troubleshootConfirmation = document.getElementsByClassName('troubleshootPlayerConfirmation')[0];

	troubleshootConfirmation.classList.add('visible');

};

EmbedSettings.prototype.troubleshootPlayerCancel = function( evt )
{
	evt.preventDefault();

	var troubleshootConfirmation = document.getElementsByClassName('troubleshootPlayerConfirmation')[0];

	troubleshootConfirmation.classList.remove('visible');

};

EmbedSettings.prototype.menuClick = function( evt )
{

	evt.preventDefault();

	var href = evt.target.getAttribute('href');

	this.loadPage( href.replace('#', '') );

};

EmbedSettings.prototype.loadPage = function( pageName )
{

	var menuItems = document.getElementsByClassName('menuOption');
	var sections  = document.getElementsByClassName('page');

	for( var i = 0; i < menuItems.length; i++ )
	{

		if( menuItems[ i ].getAttribute('href') == '#' + pageName )
		{

			menuItems[ i ].classList.add('current');

		}
		else
		{
			menuItems[ i ].classList.remove('current');			
		}

	}

	for( var i = 0; i < sections.length; i++ )
	{

		if( sections[ i ].getAttribute('id') == pageName )
		{

			sections[ i ].classList.add('current');

		}
		else
		{
			sections[ i ].classList.remove('current');			
		}

	}

	switch( pageName )
	{
		case 'home' :

			this.loadHomeDetails();

		break;

		case 'network' :
			this.loadNetwork();
		break;

		case 'outputs' :
			this.loadOutputs();
		break;

		case 'troubleshoot' :

		break;
	}

};

EmbedSettings.prototype.loadHomeDetails = function()
{

	var dataKeys = Object.keys(data.device);

	for( var i = 0; i < dataKeys.length; i++ )
	{

		var statistic = document.getElementsByClassName('stat-' + dataKeys[i]);

		if( statistic.length )
		{

			statistic[0].innerText = data.device[ dataKeys[ i ] ];

		}

	}

	var dataKeys = Object.keys(data.device.stats);

	for( var i = 0; i < dataKeys.length; i++ )
	{

		var statistic = document.getElementsByClassName('stat-' + dataKeys[i]);

		if( statistic.length )
		{

			statistic[0].innerText = data.device.stats[ dataKeys[ i ] ];

		}

	}

};


EmbedSettings.prototype.loadOutputs = function()
{
	var outputSelectSingle = document.getElementById('resolutionOverride');
	var outputResolutions = document.getElementsByClassName('outputResolution');

	var multiOutputs = document.getElementsByClassName('multiOutputs')[0];
	var singleOutputs = document.getElementsByClassName('singleOutputs')[0];

	if( data.stats.multiOutputs )
	{
		singleOutputs.classList.add('hidden');
		multiOutputs.classList.remove('hidden');

		this.loadMultiOutputs();
	}
	else
	{
		singleOutputs.classList.remove('hidden');
		multiOutputs.classList.add('hidden');

		// this.loadMultiOutputs();
	}

	// var outputSelect = document.createDocumentFragment();
	outputSelectSingle.innerHTML = '';

	for( var i = 0; i < data.stats.availableRes.length; i++ )
	{

		var option = document.createElement('option');

		option.value = data.stats.availableRes[ i ].modeName;
		option.innerText = data.stats.availableRes[ i ].modeName;

		if( data.stats.availableRes[ i ].modeName == data.stats.resolution.modeName )
		{
			option.setAttribute('selected', true);
		}
		else
		{
			option.removeAttribute('selected');
		}

		outputSelectSingle.appendChild(option.cloneNode(true));

	}

};

EmbedSettings.prototype.loadMultiOutputs = function()
{

	var multiOutputsInner = document.getElementsByClassName('multiOutputsInner')[0];
	multiOutputsInner.innerHTML = '';

	for( var i = 0; i < data.stats.multiOutputs.length; i++ )
	{
		var wrap = '<div class="box-inner">';
		
			wrap += '<div class="clearfix" style="padding: 10px; border-bottom: 1px solid #efefef;">';
				wrap += '<input type="hidden" value="' + data.stats.multiOutputs[i].outputName + '" />';
				wrap += '<div style="float: right">';
					wrap += '<select name="multiOutputs['+i+'][enabled]" id="outputEnabled' + i + '" class="outputEnabled" style="width: 95px;">';
						wrap += '<option value="false" ' + ( !data.stats.multiOutputs[i].enabled ? 'selected' : '' ) + '>Disabled</option>';
						wrap += '<option value="true" ' + ( data.stats.multiOutputs[i].enabled ? 'selected' : '' ) + '>Enabled</option>';
					wrap += '</select>';
				wrap += '</div>';

				wrap += '<p>' + data.stats.multiOutputs[i].outputName + '</p>';
			
			wrap += '</div>';
		
			wrap += '<div class="clearfix" style="padding: 10px;">';
			wrap += '<p>Resolution</p>';
			wrap += '<select name="multiOutputs['+i+'][videoMode]" id="resolutionOverride' + i + '" class="outputResolution">';
			for( var e = 0; e < data.stats.availableRes.length; e++ )
			{
		
				wrap += '<option value="' + data.stats.availableRes[ e ].modeName + '" ' + ( data.stats.multiOutputs[i].videoMode && data.stats.availableRes[ e ].modeName == data.stats.multiOutputs[i].videoMode.replace(':fullres', '') ? 'selected' : '' ) + '>' + data.stats.availableRes[ e ].modeName + '</option>';
				
			}
			wrap += '</select>';

			wrap += '<p>Orientation</p>';
			wrap += '<select name="multiOutputs['+i+'][transform]" id="resolutionOrientation' + i + '" class="outputOrientation">';
				wrap += '<option value="normal" ' + ( data.stats.multiOutputs[i].transform == 'normal' ? 'selected' : '' ) + '>Landscape</option>';
				wrap += '<option value="90" ' + ( data.stats.multiOutputs[i].transform == '90' ? 'selected' : '' ) + '>Portrait</option>';
				wrap += '<option value="180" ' + ( data.stats.multiOutputs[i].transform == '180' ? 'selected' : '' ) + '>Landscape Reverse</option>';
				wrap += '<option value="270" ' + ( data.stats.multiOutputs[i].transform == '270' ? 'selected' : '' ) + '>Portrait Reverse</option>';
			wrap += '</select>';

			wrap += '<div class="clearfix">';
				wrap += '<div class="half">';
					wrap += '<p>Top</p>';
					wrap += '<input type="number" value="' + ( data.stats.multiOutputs[i].screenY ? data.stats.multiOutputs[i].screenY : 0 ) + '" name="multiOutputs['+i+'][screenY]" id="top' + i + '" />';
				wrap += '</div>';

				wrap += '<div class="half">';
					wrap += '<p>Left</p>';
					wrap += '<input type="number" value="' + ( data.stats.multiOutputs[i].screenX ? data.stats.multiOutputs[i].screenX : 0 ) + '" name="multiOutputs['+i+'][screenX]" id="left' + i + '" />';
				wrap += '</div>';
			wrap += '</div>';
			wrap += '</div>';

		wrap += '</div>';

		var frag = document.createElement('div');
		frag.classList.add('quarter');
		frag.classList.add('multiOutputConfig');
		frag.innerHTML = wrap;

		multiOutputsInner.appendChild(frag);
		
	}

};

EmbedSettings.prototype.loadNetwork = function()
{

	// var isDHCP = true;
	// var defaultGateway = '';

	// if( data.network.ethernet && data.network.ethernet.config.ipAddressList )
	// {

	// 	for( var i = 0; i < data.network.ethernet.config.ipAddressList.length; i++ )
	// 	{

	// 		if( data.network.ethernet.config.ipAddressList[ i ].address )
	// 		{

	// 			isDHCP = false;

	// 			defaultGateway = data.network.ethernet.config.ipAddressList[ i ].gateway;

	// 		}

	// 	}

	// }

	
	var ethIPs = document.getElementsByClassName('ethernetIPS')[0];
	var networkInterfaceOption = document.getElementById('networkInterface');

	var ipAddress = document.getElementById('ethIP');
	var subnet = document.getElementById('ethSubnet');
	var gateway = document.getElementById('ethGateway');
	var dns = document.getElementById('ethDNS');

	

	var currentAvailable = false;

	for( var i = 0; i < data.network.available.length; i++ )
	{

		if( data.network.current && data.network.available[i].interface == data.network.current.networkinterface )
		{
			currentAvailable = data.network.available[i];
		}

	}

	if( !currentAvailable && data.network.available[0] )
	{
		currentAvailable = data.network.available[0];
	}

	if( currentAvailable )
	{
		ipAddress.value = currentAvailable.address;
		subnet.value = currentAvailable.netmask;

		if( data.network.current && data.network.current.networktype == 'manual' && data.network.current.ipaddress )
		{
			ipAddress.value = data.network.current.ipaddress;
		}

		if( data.network.current && data.network.current.networktype == 'manual' && data.network.current.subnetmask )
		{
			subnet.value = data.network.current.subnetmask;
		}

		if( data.network.current && data.network.current.dns1 )
		{
			var dnsValue = data.network.current.dns1;

			if( data.network.current.dns2 )
			{
				dnsValue = dnsValue += ',' + data.network.current.dns2;
			}

			if( data.network.current.dns3 )
			{
				dnsValue = dnsValue += ',' + data.network.current.dns3;
			}

			dns.value = dnsValue;
		}
		else if( currentAvailable.dns && currentAvailable.dns.length )
		{

			var dnsValue = '';

			for( var i = 0; i < currentAvailable.dns.length; i++ )
			{

				if( i == 0 )
				{
					dnsValue = dnsValue += currentAvailable.dns[i];
				}
				else
				{
					dnsValue = dnsValue += ',' + currentAvailable.dns[i];	
				}

			}

			dns.value = dnsValue;

		}

		// 


		if( data.network.current && data.network.current.gateway )
		{
			gateway.value = data.network.current.gateway;
		}
		else if( currentAvailable && currentAvailable.dns[0] )
		{
			gateway.value = currentAvailable.dns[0];
		}
	}


	var ethDHCPOn 	= document.getElementById('ethDHCPOn');
	var ethDHCPOff 	= document.getElementById('ethDHCPOff');

	var wifiSettings = document.getElementsByClassName('wifiSettings')[0];
	
	if( data.network.current && data.network.current.networkinterface == 'wifi' )
	{

		var wifiPassword = document.querySelectorAll('[name="wifi[password]"]')[0];
		// wifiPassword.value = data.network.current.wifipassword;

		this.loadWifiList();


		wifiSettings.classList.add('active');

		networkInterfaceOption.value = 'wifi';
	}
	else
	{
		networkInterfaceOption.value = 'ethernet';
		wifiSettings.classList.remove('active');
	}

	if( data.network.current && data.network.current.networktype == 'manual' )
	{

		ethDHCPOff.checked = true;
		ethDHCPOn.checked = false;

		ethIPs.classList.add('active');

	}
	else
	{

		ethDHCPOff.checked = false;
		ethDHCPOn.checked = true;

		ethIPs.classList.remove('active');
	
	}

};

EmbedSettings.prototype.loadWifiList = function()
{

	// var params = this.getPostData(this.options.data);
    var request = new XMLHttpRequest();

    request.open( 'GET', '/wifilist', true );

	var SSIDLoader = document.getElementById('SSIDLoader');
	var wifiNetwork = document.getElementById('wifiNetwork');
	var wifiSSIDWrap = document.getElementById('wifiSSIDWrap');

	SSIDLoader.style.display = 'block';
	wifiNetwork.style.display = 'none';

	wifiSSIDWrap.style.display = 'none';

    // request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");

    request.onload = function() {
        if( ( request.status >= 200 && request.status < 400 ) || ( request.responseText && request.responseText != '' ) ) {

        	try {
        		var resdata = JSON.parse(request.responseText);	
        	}
            catch (e)
            {
            	var resdata = request.responseText;
            }

			this.loadWifiOptions(resdata);

			SSIDLoader.style.display = 'none';
			wifiNetwork.style.display = 'block';
        } 
        else 
        {
			console.log('error', e);
        }
    }.bind(this);

    request.onerror = function(e) {

        console.log('error', e);

    }.bind(this);

    request.send();

};

EmbedSettings.prototype.loadWifiOptions = function(resdata)
{

	var wifiNetworkOption = document.getElementById('wifiNetwork');
	var usedSSIDs = [];

	for( var i = 0; i < resdata.length; i++ )
	{
		if( usedSSIDs.indexOf(resdata[i].essId) == -1 && resdata[i].essId )
		{
			usedSSIDs.push(resdata[i].essId);

			var option = document.createElement('option');
			option.value = resdata[i].essId;
			option.innerText = resdata[i].essId;

			if( data.network.current && data.network.current.wifissid == resdata[i].essId )
			{
				option.selected = true;
			}

			wifiNetworkOption.appendChild(option);
		}
		
	}

	var option = document.createElement('option');
	option.value 		= 'Other';
	option.innerText	= 'Other';

	wifiNetworkOption.appendChild(option);

	this.toggleWifiNetworkConfig();
};

EmbedSettings.prototype.toggleWifiNetworkConfig = function()
{
	var wifiNetworkOption = document.getElementById('wifiNetwork');
	var wifiSSIDWrap = document.getElementById('wifiSSIDWrap');

	var wifiSSIDInput = wifiSSIDWrap.getElementsByTagName('input')[0];

	if( wifiNetworkOption.value == 'Other' )
	{
		wifiSSIDWrap.style.display = 'block';
	}
	else
	{
		wifiSSIDWrap.style.display = 'none';
		wifiSSIDInput.value = wifiNetworkOption.value;
	}
};

EmbedSettings.prototype.toggleIPConfig = function()
{

	var ethIPs = document.getElementsByClassName('ethernetIPS')[0];
	var ethDHCPOn 	= document.getElementById('ethDHCPOn');
	var ethDHCPOff 	= document.getElementById('ethDHCPOff');

	if( ethDHCPOn.checked )
	{

		ethIPs.classList.remove('active');

	}
	else
	{

		ethIPs.classList.add('active');

	}

};

EmbedSettings.prototype.toggleInterfaceConfig = function()
{

	var wifiSettings = document.getElementsByClassName('wifiSettings')[0];
	var interface 	= document.getElementById('networkInterface');

	if( interface.value == 'wifi' )
	{
		wifiSettings.classList.add('active');
		this.loadWifiList();
	}
	else
	{
		wifiSettings.classList.remove('active');
	}

};

EmbedSettings.prototype.loadModules = function()
{

	// this.modules = {
	// 	'registry' 	: require("@brightsign/registry"),
	// 	'network'	: require("@brightsign/networkconfiguration")
	// };

	// this.classes = {
	// 	'registry' : new this.modules.registry(),
	// 	'ethernet' : new this.modules.network('ethernet')
	// };

};

EmbedSettings.prototype.loadConfiguration = function()
{

	// var ethernetConfig = this.classes.ethernet.getConfig();


};





EmbedSettings.prototype.loadSetup = function()
{

	this.loadNetwork();
	this.loadOutputs();

};






